<template>
    <v-menu
        v-model="menu"
        offset-y
        bottom
    >
        <template v-slot:activator="{ on }">
            <v-avatar
                class="avatar"
                :color="randomColor"
                v-on="on"
            >
                <span class="white--text headline">{{ name }}</span>
            </v-avatar>
        </template>

        <v-card class="menu-card">
            <v-card-text class="caption text--secondary font-weight-bold text-uppercase pb-2">
                {{ $t('welcome') }}!
            </v-card-text>

            <v-list>
                <v-list-item
                    v-for="item in items"
                    :key="item.text"
                    :to="item.to"
                >
                    <v-list-item-action>
                        <v-icon :color="item.color ? item.color: 'primary' ">{{ item.icon }}</v-icon>
                    </v-list-item-action>
                    <v-list-item-content>
                        <v-list-item-title class="default--text">
                            {{ item.text }}
                        </v-list-item-title>
                    </v-list-item-content>
                </v-list-item>
                <v-list-item
                    @click="logout"
                    link
                >
                    <v-list-item-action>
                        <v-icon color="black">mdi-logout</v-icon>
                    </v-list-item-action>
                    <v-list-item-content>
                        <v-list-item-title class="default--text">
                            {{ $t('logout') }}
                        </v-list-item-title>
                    </v-list-item-content>
                </v-list-item>
            </v-list>
        </v-card>
        <form ref="logout" method="post" action="/logout">
            <input type="hidden" name="_token" :value="csrf"/>
        </form>
    </v-menu>
</template>

<script>
    import {mapGetters, mapMutations} from "vuex";

    export default{
        name: "AccountMenu",
        data: () => ({
            menu: false,
            csrf: document.querySelector('meta[name="csrf-token"]').getAttribute('content')
        }),
        computed: {
            ...mapGetters('auth', {
                user: 'getUser'
            }),

            profile() {
                return this.user.profile;
            },

            items() {
                return [
                    {
                        icon: 'mdi-account-circle',
                        text: this.$t('profile'),
                        color: 'black',
                        to: '/profile',
                        permission: 'profile.view'
                    },
                    {
                        icon: 'mdi-lock-reset',
                        text: this.$t('password'),
                        color: 'black',
                        to: '/change/password',
                        permission: 'profile.edit'
                    }
                ]
            },

            name() {
                const first = this.profile.first_name.charAt(0);
                const last = this.profile.last_name.charAt(0);

                return last.toUpperCase() + first.toUpperCase();
            },

            randomColor() {
                let colors = ['red', 'pink', 'orange', 'purple', 'cyan', 'teal', 'lime', 'green', 'deep-orange'];
                return colors[Math.floor(Math.random() * colors.length)];
            },
        },
        methods: {
            ...mapMutations('auth', [
                'clearUser'
            ]),

            logout() {
                this.$refs.logout.submit();
                this.clearUser();
            }
        }
    }
</script>

<style scoped>
    .avatar:hover {
        opacity: 0.6;
        cursor: pointer;
    }
</style>
